package mx.containers
{
   import flash.display.DisplayObject;
   import flash.geom.Rectangle;
   import mx.containers.utilityClasses.CanvasLayout;
   import mx.core.Container;
   import mx.core.EdgeMetrics;
   import mx.core.IUIComponent;
   import mx.core.mx_internal;
   import mx.styles.IStyleClient;
   
   use namespace mx_internal;
   
   public class Canvas extends Container
   {
      mx_internal static const VERSION:String = "2.0.1.0";
      
      private var layoutObject:CanvasLayout;
      
      public function Canvas()
      {
         layoutObject = new CanvasLayout();
         super();
         layoutObject.target = this;
      }
      
      override mx_internal function get usePadding() : Boolean
      {
         return false;
      }
      
      override mx_internal function getScrollableRect() : Rectangle
      {
         var _loc1_:Number = NaN;
         var _loc2_:Number = NaN;
         var _loc3_:Number = NaN;
         var _loc4_:Number = NaN;
         var _loc5_:int = 0;
         var _loc6_:int = 0;
         var _loc7_:EdgeMetrics = null;
         var _loc8_:Rectangle = null;
         var _loc9_:DisplayObject = null;
         var _loc10_:Number = NaN;
         var _loc11_:Number = NaN;
         _loc1_ = 0;
         _loc2_ = 0;
         _loc3_ = 0;
         _loc4_ = 0;
         _loc5_ = numChildren;
         _loc6_ = 0;
         while(_loc6_ < _loc5_)
         {
            _loc9_ = getChildAt(_loc6_);
            _loc10_ = 0;
            _loc11_ = 0;
            if(!(_loc9_ is IUIComponent && !IUIComponent(_loc9_).includeInLayout))
            {
               _loc1_ = Math.min(_loc1_,_loc9_.x);
               _loc2_ = Math.min(_loc2_,_loc9_.y);
               if(_loc9_ is IStyleClient)
               {
                  _loc10_ = Number(IStyleClient(_loc9_).getStyle("right"));
                  _loc11_ = Number(IStyleClient(_loc9_).getStyle("bottom"));
                  if(isNaN(_loc10_))
                  {
                     _loc10_ = 0;
                  }
                  if(isNaN(_loc11_))
                  {
                     _loc11_ = 0;
                  }
               }
               if(!isNaN(_loc9_.width))
               {
                  _loc3_ = Math.max(_loc3_,_loc9_.x + _loc9_.width + _loc10_);
               }
               if(!isNaN(_loc9_.height))
               {
                  _loc4_ = Math.max(_loc4_,_loc9_.y + _loc9_.height + _loc11_);
               }
            }
            _loc6_++;
         }
         _loc7_ = viewMetrics;
         _loc8_ = new Rectangle();
         _loc8_.left = _loc1_;
         _loc8_.top = _loc2_;
         _loc8_.right = _loc3_;
         _loc8_.bottom = _loc4_;
         if(mx_internal::usePadding)
         {
            _loc8_.right += getStyle("paddingRight");
            _loc8_.bottom += getStyle("paddingBottom");
         }
         return _loc8_;
      }
      
      override protected function measure() : void
      {
         super.measure();
         layoutObject.measure();
      }
      
      override protected function updateDisplayList(param1:Number, param2:Number) : void
      {
         super.updateDisplayList(param1,param2);
         layoutObject.updateDisplayList(param1,param2);
      }
   }
}

