package mx.controls
{
   import flash.display.Sprite;
   import flash.system.ApplicationDomain;
   import mx.containers.Panel;
   import mx.controls.alertClasses.AlertForm;
   import mx.core.Application;
   import mx.core.EdgeMetrics;
   import mx.core.mx_internal;
   import mx.events.CloseEvent;
   import mx.managers.PopUpManager;
   import mx.resources.ResourceBundle;
   
   use namespace mx_internal;
   
   public class Alert extends Panel
   {
      mx_internal static var createAccessibilityImplementation:Function;
      
      private static var resourceNoLabel:String;
      
      private static var resourceOkLabel:String;
      
      private static var resourceCancelLabel:String;
      
      private static var resourceYesLabel:String;
      
      mx_internal static const VERSION:String = "2.0.1.0";
      
      public static const YES:uint = 1;
      
      public static const NO:uint = 2;
      
      public static const OK:uint = 4;
      
      public static const CANCEL:uint = 8;
      
      public static const NONMODAL:uint = 32768;
      
      private static var packageResources:ResourceBundle = ResourceBundle.getResourceBundle("controls",ApplicationDomain.currentDomain);
      
      public static var buttonHeight:Number = 22;
      
      public static var buttonWidth:Number = 60;
      
      public static var cancelLabel:String = "";
      
      public static var noLabel:String = "";
      
      public static var okLabel:String = "";
      
      public static var yesLabel:String = "";
      
      loadResources();
      
      mx_internal var alertForm:AlertForm;
      
      public var iconClass:Class;
      
      private var init:Boolean = false;
      
      public var text:String = "";
      
      public var buttonFlags:uint = 4;
      
      public var defaultButtonFlag:uint = 4;
      
      public function Alert()
      {
         init = false;
         buttonFlags = OK;
         defaultButtonFlag = OK;
         text = "";
         super();
         title = "";
      }
      
      private static function bundleChanged() : void
      {
         okLabel = resourceOkLabel;
         yesLabel = resourceYesLabel;
         noLabel = resourceNoLabel;
         cancelLabel = resourceCancelLabel;
      }
      
      private static function loadResources() : void
      {
         resourceCancelLabel = packageResources.getString("cancelLabel");
         resourceNoLabel = packageResources.getString("noLabel");
         resourceOkLabel = packageResources.getString("okLabel");
         resourceYesLabel = packageResources.getString("yesLabel");
         bundleChanged();
      }
      
      public static function show(param1:String = "", param2:String = "", param3:uint = 4, param4:Sprite = null, param5:Function = null, param6:Class = null, param7:uint = 4) : Alert
      {
         var _loc8_:Boolean = false;
         var _loc9_:Alert = null;
         _loc8_ = !!(param3 & Alert.NONMODAL) ? false : true;
         if(!param4)
         {
            param4 = Sprite(Application.application);
         }
         _loc9_ = new Alert();
         if(Boolean(param3 & Alert.OK) || Boolean(param3 & Alert.CANCEL) || Boolean(param3 & Alert.YES) || Boolean(param3 & Alert.NO))
         {
            _loc9_.buttonFlags = param3;
         }
         if(param7 == Alert.OK || param7 == Alert.CANCEL || param7 == Alert.YES || param7 == Alert.NO)
         {
            _loc9_.defaultButtonFlag = param7;
         }
         _loc9_.text = param1;
         _loc9_.title = param2;
         _loc9_.iconClass = param6;
         if(param5 != null)
         {
            _loc9_.addEventListener(CloseEvent.CLOSE,param5);
         }
         PopUpManager.addPopUp(_loc9_,param4,_loc8_);
         _loc9_.setActualSize(_loc9_.getExplicitOrMeasuredWidth(),_loc9_.getExplicitOrMeasuredHeight());
         return _loc9_;
      }
      
      override protected function measure() : void
      {
         var _loc1_:EdgeMetrics = null;
         super.measure();
         _loc1_ = viewMetrics;
         measuredWidth = Math.max(measuredWidth,mx_internal::alertForm.getExplicitOrMeasuredWidth() + _loc1_.left + _loc1_.right);
         measuredHeight = mx_internal::alertForm.getExplicitOrMeasuredHeight() + _loc1_.top + _loc1_.bottom;
      }
      
      override protected function createChildren() : void
      {
         var _loc1_:String = null;
         super.createChildren();
         _loc1_ = getStyle("messageStyleName");
         if(_loc1_)
         {
            styleName = _loc1_;
         }
         if(!mx_internal::alertForm)
         {
            mx_internal::alertForm = new AlertForm();
            mx_internal::alertForm.styleName = this;
            addChild(mx_internal::alertForm);
         }
      }
      
      override protected function initializeAccessibility() : void
      {
         if(Alert.mx_internal::createAccessibilityImplementation != null)
         {
            Alert.mx_internal::createAccessibilityImplementation(this);
         }
      }
      
      override public function styleChanged(param1:String) : void
      {
         var _loc2_:String = null;
         super.styleChanged(param1);
         if(param1 == "messageStyleName")
         {
            _loc2_ = getStyle("messageStyleName");
            styleName = _loc2_;
         }
         if(mx_internal::alertForm)
         {
            mx_internal::alertForm.styleChanged(param1);
         }
      }
      
      override protected function updateDisplayList(param1:Number, param2:Number) : void
      {
         var _loc3_:EdgeMetrics = null;
         var _loc4_:Number = NaN;
         var _loc5_:Number = NaN;
         super.updateDisplayList(param1,param2);
         _loc3_ = viewMetrics;
         mx_internal::alertForm.setActualSize(param1 - _loc3_.left - _loc3_.right - getStyle("paddingLeft") - getStyle("paddingRight"),param2 - _loc3_.top - _loc3_.bottom - getStyle("paddingTop") - getStyle("paddingBottom"));
         if(!init)
         {
            if(parent == systemManager)
            {
               _loc4_ = (screen.width - measuredWidth) / 2;
               _loc5_ = (screen.height - measuredHeight) / 2;
            }
            else
            {
               _loc4_ = (parent.width - measuredWidth) / 2;
               _loc5_ = (parent.height - measuredHeight) / 2;
            }
            move(Math.round(_loc4_),Math.round(_loc5_));
            init = true;
         }
      }
   }
}

