package mx.messaging
{
   import mx.collections.ArrayList;
   import mx.core.mx_internal;
   import mx.utils.Translator;
   import mx.utils.UIDUtil;
   
   public class Session
   {
      private static const TRANSLATOR:Translator = Translator.getDefaultInstanceFor(Session);
      
      private var _clientId:String = null;
      
      private var _agents:ArrayList;
      
      public function Session(param1:String = null)
      {
         _clientId = null;
         super();
         _clientId = param1 != null ? param1 : UIDUtil.createUID();
      }
      
      public function addAgent(param1:MessageAgent) : void
      {
         if(!_agents)
         {
            _agents = new ArrayList();
         }
         if(_agents.getItemIndex(param1) == -1)
         {
            _agents.addItem(param1);
            param1.mx_internal::setClientId(clientId);
         }
      }
      
      public function get clientId() : String
      {
         return _clientId;
      }
      
      public function removeAgent(param1:MessageAgent) : void
      {
         if(Boolean(_agents) && _agents.removeItem(param1))
         {
            param1.mx_internal::setClientId(null);
         }
      }
      
      public function set clientId(param1:String) : void
      {
         var _loc2_:MessageAgent = null;
         var _loc3_:uint = 0;
         if(param1 != _clientId)
         {
            if(param1 != null && param1.length == 0)
            {
               throw new ArgumentError(TRANSLATOR.textOf("emptySessionClientId"));
            }
            if(param1 == null)
            {
               _clientId = UIDUtil.createUID();
            }
            else
            {
               _clientId = param1;
               _loc3_ = 0;
               while(_loc3_ < _agents.length)
               {
                  _loc2_ = MessageAgent(_agents.getItemAt(_loc3_));
                  _loc2_.mx_internal::setClientId(param1);
                  _loc3_++;
               }
            }
         }
      }
   }
}

