package mx.messaging.messages
{
   import mx.utils.Translator;
   
   public class HTTPRequestMessage extends AbstractMessage
   {
      public static const CONTENT_TYPE_XML:String = "application/xml";
      
      public static const CONTENT_TYPE_FORM:String = "application/x-www-form-urlencoded";
      
      public static const CONTENT_TYPE_SOAP_XML:String = "text/xml; charset=utf-8";
      
      public static const POST_METHOD:String = "POST";
      
      public static const GET_METHOD:String = "GET";
      
      public static const PUT_METHOD:String = "PUT";
      
      public static const HEAD_METHOD:String = "HEAD";
      
      public static const DELETE_METHOD:String = "DELETE";
      
      public static const OPTIONS_METHOD:String = "OPTIONS";
      
      public static const TRACE_METHOD:String = "TRACE";
      
      private static const TRANSLATOR:Translator = Translator.getDefaultInstanceFor(HTTPRequestMessage);
      
      private static const VALID_METHODS:String = "POST,PUT,GET,HEAD,DELETE,OPTIONS,TRACE";
      
      private var _method:String;
      
      public var contentType:String;
      
      public var recordHeaders:Boolean;
      
      public var httpHeaders:Object;
      
      public var url:String;
      
      public function HTTPRequestMessage()
      {
         super();
         _method = GET_METHOD;
      }
      
      public function set method(param1:String) : void
      {
         if(VALID_METHODS.indexOf(param1) == -1)
         {
            throw new ArgumentError(TRANSLATOR.textOf("invalidRequestMethod"));
         }
         _method = param1;
      }
      
      public function get method() : String
      {
         return _method;
      }
   }
}

