package mx.rpc
{
   public class ActiveCalls
   {
      private var numActive:uint;
      
      private var lastCallId:String;
      
      private var calls:Object;
      
      public function ActiveCalls()
      {
         super();
         calls = {};
         numActive = 0;
      }
      
      public function removeCall(param1:String) : AsyncToken
      {
         var _loc2_:AsyncToken = null;
         _loc2_ = calls[param1];
         if(_loc2_ != null)
         {
            --numActive;
            delete calls[param1];
         }
         return _loc2_;
      }
      
      public function cancelLast() : void
      {
         if(lastCallId)
         {
            removeCall(lastCallId);
         }
         lastCallId = null;
      }
      
      public function getAllMessages() : Array
      {
         var _loc1_:Array = null;
         var _loc2_:String = null;
         _loc1_ = new Array();
         for(_loc2_ in calls)
         {
            _loc1_.push(calls[_loc2_]);
         }
         return _loc1_;
      }
      
      public function hasActiveCalls() : Boolean
      {
         return numActive > 0;
      }
      
      public function wasLastCall(param1:String) : Boolean
      {
         return lastCallId == param1;
      }
      
      public function addCall(param1:String, param2:AsyncToken) : void
      {
         calls[param1] = param2;
         ++numActive;
         lastCallId = param1;
      }
   }
}

